include masm32rt.inc

DlgProc proto :DWORD,:DWORD,:DWORD,:DWORD
CmpIcon proto hIcon1:DWORD,hIcon2:DWORD

.data?
	hInstance		dd ?
	_hIcon1			dd ?
	_hIcon2			dd ?
	pszFileName2	dd ?
	szFileName1		db 260 dup (?)
.code
start:
	mov hInstance,rv(GetModuleHandle,0)
	cst OFFSET szFileName1,OpenFileDlg(0,hInstance,"Select file 1",0)
	mov pszFileName2,OpenFileDlg(0,hInstance,"Select file 2",0)
	
    Dialog  "FileInfo","FixedSys",12,WS_OVERLAPPED or WS_SYSMENU or DS_CENTER or WS_SIZEBOX,2,0,0,100,100,150
    DlgStatic "Icon",SS_ICON,0,0,30,30,1
    DlgStatic "Icon",SS_ICON,0,0,30,30,2
	CallModalDialog hInstance, 0, DlgProc, NULL
	invoke ExitProcess,0

DlgProc proc hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL rect:RECT
LOCAL shfi:SHFILEINFO

	.if uMsg == WM_CLOSE
		invoke DestroyIcon,_hIcon1					; do not forget to delete Icons returned by SHGetFileInfo !!!
		invoke DestroyIcon,_hIcon2
		invoke EndDialog,hDlg,0
	.elseif uMsg == WM_INITDIALOG
		invoke SHGetFileInfo,OFFSET szFileName1,0,ADDR shfi,SIZEOF shfi, SHGFI_ICON or SHGFI_LARGEICON or SHGFI_DISPLAYNAME
		m2m _hIcon1,shfi.hIcon
		invoke SHGetFileInfo,pszFileName2,0,ADDR shfi,SIZEOF shfi, SHGFI_ICON or SHGFI_LARGEICON or SHGFI_DISPLAYNAME
		m2m _hIcon2,shfi.hIcon

		invoke CmpIcon,_hIcon1,_hIcon2		; compare icons
		.if eax
			fn MessageBox,hDlg,"icons are equal","equal",MB_OK
			fn SetWindowText,hDlg,"equal"
		.else
			fn MessageBox,hDlg,"icons are not equal","not equal",MB_OK
			fn SetWindowText,hDlg,"not equal"
		.endif

		invoke SendDlgItemMessage,hDlg,1,STM_SETIMAGE,IMAGE_ICON,_hIcon1
		invoke SendDlgItemMessage,hDlg,2,STM_SETIMAGE,IMAGE_ICON,_hIcon2  
	.elseif WM_SIZE
		.if wParam == SIZE_RESTORED
			invoke GetClientRect,hDlg,ADDR rect
			invoke SetWindowPos,rv(GetDlgItem,hDlg,1),0,0,0,0,0,SWP_NOSIZE or SWP_NOZORDER
			mov edx,rv(GetDlgItem,hDlg,2)
			mov ecx,rect.right
			shr ecx,1
			invoke SetWindowPos,edx,0,ecx,0,0,0,SWP_NOSIZE or SWP_NOZORDER
		.endif
		xor eax,eax
		ret
	.else
		xor eax,eax
		ret
	.endif
	mov eax,1
	ret
DlgProc endp

CmpIcon proc uses edi esi hIcon1:DWORD,hIcon2:DWORD
LOCAL icf1:ICONINFO
LOCAL icf2:ICONINFO
LOCAL bmp1:BITMAP
LOCAL bmp2:BITMAP
LOCAL hdc:HDC
LOCAL bi:BITMAPINFO
LOCAL pBits1:DWORD
LOCAL pBits2:DWORD

	invoke GetIconInfo,hIcon1,ADDR icf1
	test eax,eax
	jz @error
	invoke GetIconInfo,hIcon2,ADDR icf2
	test eax,eax
	jz @error
	
	invoke GetObject,icf1.hbmColor,sizeof BITMAPINFO,ADDR bmp1
	test eax,eax
	jz @error	
	
	invoke GetObject,icf2.hbmColor,sizeof BITMAPINFO,ADDR bmp2
	test eax,eax
	jz @error	
	
	mov hdc,rv(CreateCompatibleDC,rv(GetDC,0))
	
	mov edx,bmp1.bmWidth
	mov ecx,bmp1.bmHeight
	.if bmp2.bmWidth != edx || bmp2.bmHeight != ecx
		xor eax,eax
		ret
	.endif
	
	mov edx,bmp1.bmWidth
	mov eax,bmp1.bmHeight

	mov bi.bmiHeader.biSize,SIZEOF BITMAPINFO
	mov bi.bmiHeader.biWidth,edx
	mov bi.bmiHeader.biHeight,eax
	mov bi.bmiHeader.biPlanes,1
	mov bi.bmiHeader.biCompression,BI_RGB
	mov bi.bmiHeader.biBitCount,32
	mov bi.bmiHeader.biSizeImage,0
	mov bi.bmiHeader.biXPelsPerMeter,0
	mov bi.bmiHeader.biYPelsPerMeter,0
	mov bi.bmiHeader.biClrUsed,0
	mov bi.bmiHeader.biClrImportant,0
	
	mul edx			; bmWidth*bmHeight
	mov edi,eax		; store number of pixels
	lea esi,[eax*4]	; calc buffer size

	mov pBits1,rv(GlobalAlloc,GPTR,esi)
	mov pBits2,rv(GlobalAlloc,GPTR,esi)
	
	; get the bits
	invoke GetDIBits,hdc,icf1.hbmColor,0,bmp1.bmHeight,pBits1,ADDR bi,DIB_RGB_COLORS
	invoke GetDIBits,hdc,icf2.hbmColor,0,bmp1.bmHeight,pBits2,ADDR bi,DIB_RGB_COLORS
	
	; a simple dword-scanner for compare bitmaps
	cld
	mov ecx,edi
	mov edi,pBits1
	mov esi,pBits2
	repe cmpsd
	sete al
	movzx edi,al	; save result (0 or 1 ;))
	
	invoke DeleteDC,hdc
	invoke GlobalFree,pBits1
	invoke GlobalFree,pBits2
	mov eax,edi	
	ret

@error:
	xor eax,eax
	ret

CmpIcon endp

end start